function [G_mn] = Assembly_Nop(L,M,N,Np_GL,n_medium,ko,dx,dy,dz,R_faces)
%%
% addpath('.\SRC_CIRCULANT_Nop\CUBATURES_Nop')
% addpath('.\SRC_CIRCULANT_Nop\DEMCEM')
% addpath('.\SRC_CIRCULANT_Nop\DEMCEM\mexDIRECT_WS_const')

% Set order of quadrature for each region
% Np_GL = [Np_DEMCEM ; Np_1D_near ; Np_1D_medium ; Np_1D_far];
Np_DEMCEM    = Np_GL(1);
Np_1D_near   = Np_GL(2);
Np_1D_medium = Np_GL(3);
Np_1D_far    = Np_GL(4);
% Allocate memory for main matrices
J_mn = zeros(L,M,N,6,6);
G_mn = zeros(L,M,N,6);
% Reference cell
r_n = [0.0 , 0.0 , 0.0]';
% Reference distance vector
d = [dx,dy,dz];
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                            ASSEMBLY
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
N_P = Np_1D_far;

[Np,wp,up,vp] = Gauss_2D_Nop(N_P);

tic
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                     Far Distance Cells
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
RR = R_faces;
kko = ko;
ddx = dx;
%
parfor mx = 1:L
    for my = 1:M
        for mz = 1:N
            m = [mx,my,mz];
            r_m = ( (m-1) .* d )';
                        
%             J_mn(mx,my,mz,:,:) = CUBATURE_2D_2D(Np_1D_far,r_m,r_n,RR,kko);
%             J_mn(mx,my,mz,:,:) = CUBATURE_Nop_sym_far(Np,wp,up,vp,r_m,r_n,RR,kko,ddx);
            J_mn(mx,my,mz,:,:) = mexCUBATURE_Nop(Np,wp,up,vp,r_m,r_n,RR,kko,ddx);
                     
        end
    end
end

Time_far = toc;
fprintf('Time_far         = %d \n',int64(Time_far));
tic
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                     Medium Distance Cells
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
N_P = Np_1D_medium;

[Np,wp,up,vp] = Gauss_2D_Nop(N_P);

parfor mx = 1:n_medium
    for my = 1:n_medium
        for mz = 1:n_medium
            
            m = [mx,my,mz];
            r_m = ( (m-1) .* d )';
                      
%             J_mn(mx,my,mz,:,:) = CUBATURE_2D_2D(Np_1D_medium,r_m,r_n,RR,kko);
%             J_mn(mx,my,mz,:,:) = CUBATURE_Nop_sym_near(Np,wp,up,vp,r_m,r_n,RR,kko,ddx);
            J_mn(mx,my,mz,:,:) = mexCUBATURE_Nop(Np,wp,up,vp,r_m,r_n,RR,kko,ddx);

                     
        end
    end
end

Time_medium = toc;
fprintf('Time_medium      = %d \n',int64(Time_medium));
tic
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                     Nearby Cells
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
N_P = Np_1D_near;

[Np,wp,up,vp] = Gauss_2D_Nop(N_P);
% Compute singular terms via DEMCEM
[I_ST] = DEMCEM_ST(Np_DEMCEM,ko,dx,dy);
[I_EAc,I_EAo] = DEMCEM_EA(Np_DEMCEM,ko,dx,dy,dz);
[I_VAc,I_VAo] = DEMCEM_VA(Np_DEMCEM,ko,dx,dy,dz);
parfor mx = 1:2
    for my = 1:2
        for mz = 1:2
            
            m = [mx,my,mz];
            r_m = ( (m-1) .* d )';
      
%             [I_mn_non_corrected] = CUBATURE_2D_2D(Np_1D_near,r_m,r_n,RR,kko);
            [I_mn_non_corrected] = CUBATURE_Nop_sym_near(Np,wp,up,vp,r_m,r_n,RR,kko,ddx);
            
            J_mn(mx,my,mz,:,:) = Nearby_Correct(m,I_mn_non_corrected,I_ST,I_EAc,I_EAo,I_VAc,I_VAo);
 
        end
    end
end

Time_near = toc;
fprintf('Time_near        = %d \n',int64(Time_near));
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                     Evaluate G_mn
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%\
tic

[P_vector] = Vector_Projection();

for kk = 1:6
    for jj = 1:6
        for ii = 1:6
            G_mn(:,:,:,kk) = G_mn(:,:,:,kk) + J_mn(:,:,:,ii,jj)*P_vector(ii,jj,kk);
        end
    end
end

Time_projection = toc;
fprintf('Time_projection  = %d \n',int64(Time_projection));

G_mn = ( 1.0 / (4*pi) ) * G_mn;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                             END
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%